# -*- coding: utf-8 -*-
# $Id: baseitem.py 3737 2008-10-26 19:14:17Z hraban $
import os
import grok
import waeup.viewlets as vw
from waeup.interfaces import IBaseItem
from zope.component import getMultiAdapter
from waeup.permissions import *

class BaseItem(grok.Model):
    """
    Base item
    """
    #grok.implements(IBaseItem)
    
    def __init__(self, **kwargs):
        super(BaseItem, self).__init__()
        self.ViewPermission = ViewBase
        self.AddPermission = AddBase
        self.EditPermission = EditBase
        self.__dict__.update(kwargs)

## Forms

class DisplayForm(grok.DisplayForm):
    #template = grok.PageTemplate(filename=os.path.join('baseitem_templates', 'content.pt'))
    grok.template('content')

    def __init__(self, context, request):
        super(DisplayForm, self).__init__(context, request)
        self.form_fields = grok.AutoFields(self.context.__class__)

# Wird wahrscheinlich nie benutzt - was sollte man einem Item hinzufügen?
class AddForm(grok.AddForm):
    template = grok.PageTemplate(filename=os.path.join('basecontainer_templates', 'edit_form.pt'))
    

    def __init__(self, context, request):
        super(AddForm, self).__init__(context, request)
        self.form_fields = grok.AutoFields(self.context.__class__)
        #grok.require(context.__class__.AddPermission)

    @grok.action('Add item')
    def add(self, **data):
        obj = self.context.__class__(**data) #.childClass(**data)
        id = data['id'].lower()
        print "Add to item %s, ID %s, Obj %s" % (self.context, id, obj)
        self.context[id] = obj
        self.redirect(self.url('@@index'))

class EditForm(grok.EditForm):
    template = grok.PageTemplate(filename=os.path.join('basecontainer_templates', 'edit_form.pt'))
    
   
    def __init__(self, context, request):
        super(EditForm, self).__init__(context, request)
        self.form_fields = grok.AutoFields(self.context.__class__)
        #grok.require(context.__class__.EditPermission)

#    def handle_edit_action(self, **data):
#        grok.EditForm.handle_edit_action(self, **data)

#    @grok.action(u"Edit item")
#    def edit(self, **data):
#        id = data['id'].lower()
#        obj = self.context[id]
#        self.applyData(obj, **data)
#        self.redirect(self.url('@@index')) # FIXME: funktioniert nicht!?

## Viewlets

class DisplayViewlet(grok.Viewlet):
    grok.viewletmanager(vw.MainArea)
    grok.context(IBaseItem)
    grok.view(vw.Index)
    #grok.order(1)
    #grok.template('content')
    
    #def __init__(self, context, request, *other):
    #    super(Index, self).__init__(context, request, *other)
    #    grok.require(self.context.__class__.ViewPermission)

    def update(self):
        self.form = getMultiAdapter((self.context, self.request),
                                    name='displayform')
        self.form.update_form()

    def render(self):
        return self.form.render()


class AddViewlet(grok.Viewlet):
    grok.viewletmanager(vw.MainArea)
    grok.context(IBaseItem)
    grok.view(vw.Add)
    #grok.name('add')
    #grok.order(2)

    def update(self):
        self.form = getMultiAdapter((self.context, self.request),
                                    name='addform')
        self.form.update_form()

    def render(self):
        return self.form.render()


class EditViewlet(grok.Viewlet):
    grok.viewletmanager(vw.MainArea)
    grok.context(IBaseItem)
    grok.view(vw.Edit)
    #grok.name('edit')
    #grok.order(2)

    def update(self):
        self.form = getMultiAdapter((self.context, self.request),
                                    name='editform')
        self.form.update_form()

    def render(self):
        return self.form.render()
