# -*- coding: utf-8 -*-
# $Id: department.py 3737 2008-10-26 19:14:17Z hraban $
import grok
import waeup.basecontainer as base
from waeup.university import permissions
from waeup.university.interfaces import IDepartment
from waeup.university.course import Course
#from waeup.university.containers import CourseContainer

class Department(base.BaseContainer):
    """
    This is a Department (part of Faculty, contains Courses)
    """
    grok.implements(IDepartment)
    childClass = Course
    name = u'Department'
    plural_name = u'Departments'
    ViewPermission = permissions.ViewDepartment
    AddPermission = permissions.AddDepartment
    EditPermission = permissions.EditDepartment

    def __init__(self, **kw):
        super(Department, self).__init__(**kw)
        self.__dict__.update(kw)

# Bei BaseContainer-Klassen müsen die beiden Viewlets ans Interface angepasst werden:

class DisplayViewlet(base.DisplayViewlet):
    grok.context(IDepartment)
    
class AddViewlet(base.AddViewlet):
    grok.context(IDepartment)
